datablock TSShapeConstructor(ChickenDts)
{
	baseShape  = "./Chicken.dts";
	sequence0  = "./chicken_root.dsq root";

	sequence1  = "./chicken_run.dsq run";
	sequence2  = "./chicken_run.dsq walk";
	sequence3  = "./chicken_run.dsq back";
	sequence4  = "./chicken_run.dsq side";

	sequence5  = "./chicken_root.dsq crouch";
	sequence6  = "./chicken_root.dsq crouchRun";
	sequence7  = "./chicken_root.dsq crouchBack";
	sequence8  = "./chicken_root.dsq crouchSide";

	sequence9  = "./chicken_root.dsq look";
	sequence10 = "./chicken_root.dsq headside";
	sequence11 = "./chicken_root.dsq headUp";

	sequence12 = "./chicken_jump.dsq jump";
	sequence13 = "./chicken_jump.dsq standjump";
	sequence14 = "./chicken_root.dsq fall";
	sequence15 = "./chicken_root.dsq land";

	sequence16 = "./chicken_root.dsq armAttack";
	sequence17 = "./chicken_root.dsq armReadyLeft";
	sequence18 = "./chicken_root.dsq armReadyRight";
	sequence19 = "./chicken_root.dsq armReadyBoth";
	sequence20 = "./chicken_root.dsq spearready";  
	sequence21 = "./chicken_root.dsq spearThrow";

	sequence22 = "./chicken_root.dsq talk";  

	sequence23 = "./chicken_death.dsq death1"; 
	
	sequence24 = "./chicken_root.dsq shiftUp";
	sequence25 = "./chicken_root.dsq shiftDown";
	sequence26 = "./chicken_root.dsq shiftAway";
	sequence27 = "./chicken_root.dsq shiftTo";
	sequence28 = "./chicken_root.dsq shiftLeft";
	sequence29 = "./chicken_root.dsq shiftRight";
	sequence30 = "./chicken_root.dsq rotCW";
	sequence31 = "./chicken_root.dsq rotCCW";

	sequence32 = "./chicken_root.dsq undo";
	sequence33 = "./chicken_root.dsq plant";

	sequence34 = "./chicken_root.dsq sit";

	sequence35 = "./chicken_root.dsq wrench";

   sequence36 = "./chicken_activate.dsq activate";
   sequence37 = "./chicken_activate.dsq activate2";

   sequence38 = "./chicken_root.dsq leftrecoil";
};    

// Give people chicken powers
nameToID("playerStandardArmor").shapeFile = "./Chicken.dts";
nameToID("playerStandardArmor").boundingBox = "4 4 4";
nameToID("playerStandardArmor").crouchBoundingBox = "4 4 4";
nameToID("playerStandardArmor").jetEmitter = "";
nameToID("playerStandardArmor").jetGroundEmitter = "";
nameToID("playerStandardArmor").uiName = "Chicken";

datablock audioDescription(ChickenCluckSoundDescription : AudioDefault3D)
{
	referenceDistance = 40;
	maxDistance = 70;
};

datablock audioProfile(ChickenCluckSound)
{
	fileName = "./cluck.wav";
	description = ChickenCluckSoundDescription;
	preload = true;
};

package chicken
{
	function player::activateStuff(%this)
	{
		%return = parent::activateStuff(%this);
		
		if(stripos(%this.getDatablock().shapeFile, "Chicken.dts") == -1)
			return %return;
		
		if($sim::time - %this.lastclucktime < 0.12)
			return %return;
		
		if($sim::time - %this.lastclucktime > 2)
			%this.numClucks = 0;
		
		if(%this.numClucks > 8)
		{
			%this.numClucks = -1;
			%this.cluckWait = $sim::time;
			return %return;
		}
		
		if(%this.numClucks == -1 && $sim::time - %this.cluckWait < 3)
			return %return;
		
		%time = $sim::time + %this.chickenOffset;
		%pitch = 1 + (msin(%time) / 6);
		
		// Concept shamelessly stolen from Paperwork's play pitched sound event mod.
		%oldTimescale = getTimescale();
		setTimescale(%pitch);
		serverPlay3D(nameToID("ChickenCluckSound"), vectorAdd(%this.getPosition(), "0 0 5"));
		setTimescale(%oldTimescale);
		
		if(!$Server::LAN)
		{
			WebCom_PostServerUpdateLoop();
			pingMatchMakerLoop();
		} // Apparently the matchmaker loop will murder your server while you're not looking if you don't do this. I dare you to comment it!
		
		%this.lastclucktime = $sim::time;
		%this.numClucks++;
		return %return;
	}
	
	function gameConnection::autoAdminCheck(%this)
	{
		%this.chickenOffset = mAbs(getRandom()); //Gives chickens more abs.
		
		return parent::autoAdminCheck(%this);
	}
};
activatePackage(chicken);

$gamemodeDisplayName = "Chicken RP";